//
//  CarouselTemplateWireframe.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit

enum CarouselTemplateStyle: String {
    case medium
    case large
    case largeSingle
    
    var mapToCellWidth: CGFloat {
        
        let cellPadding: CGFloat = 16
        let screenWidth = UIScreen.main.bounds.width
        switch self {
        case .medium:
            return (screenWidth * 0.95 - (cellPadding * 2) - 16) / 2
        case .largeSingle:
            return screenWidth - cellPadding * 2
            
        case .large:
            return screenWidth * 0.95 - cellPadding * 2
        }
    }
    
    var mapToCellHeight: CGFloat {
        return self.mapToCellWidth * 9 / 16 + 48
    }
}

final class CarouselTemplateWireframe: BaseWireframe {

    // MARK: - Private properties -

    private let storyboard = UIStoryboard(name: "CarouselTemplate", bundle: nil)

    // MARK: - Module setup -

    init(style: CarouselTemplateStyle = .medium) {
        let moduleViewController = storyboard.instantiateViewController(ofType: CarouselTemplateViewController.self)
        moduleViewController.style = style
        super.init(viewController: moduleViewController)

        let interactor = CarouselTemplateInteractor()
        let presenter = CarouselTemplatePresenter(view: moduleViewController, interactor: interactor, wireframe: self, style: style)
        moduleViewController.presenter = presenter
    }

}

// MARK: - Extensions -

extension CarouselTemplateWireframe: CarouselTemplateWireframeInterface {
}
